(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('angular-auto-scroll-to-bottom', ['exports', '@angular/core'], factory) :
    (factory((global['angular-auto-scroll-to-bottom'] = {}),global.ng.core));
}(this, (function (exports,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var ResizedEvent = /** @class */ (function () {
        function ResizedEvent(newWidth, newHeight, oldWidth, oldHeight) {
            this.newWidth = newWidth;
            this.newHeight = newHeight;
            this.oldWidth = oldWidth;
            this.oldHeight = oldHeight;
        }
        return ResizedEvent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var AutoScrollToBottomDirective = /** @class */ (function () {
        function AutoScrollToBottomDirective(element, zone, renderer) {
            var _this = this;
            this.element = element;
            this.zone = zone;
            this.renderer = renderer;
            this.autoScroll = true;
            this.autoScrollChange = new core.EventEmitter();
            this.resized = new core.EventEmitter();
            this.overflowAnchor = 'none';
            this.overflowY = 'auto';
            this.scrolling = false;
            this.onScroll = function () {
                /** @type {?} */
                var maxDelta = 2;
                if (_this.scrolling) {
                    return;
                }
                /** @type {?} */
                var el = _this.element.nativeElement;
                /** @type {?} */
                var bottom = el.scrollTop + el.offsetHeight;
                /** @type {?} */
                var height = el.scrollHeight;
                /** @type {?} */
                var atBottom = height - bottom < maxDelta;
                if (_this.autoScroll !== atBottom) {
                    _this.zone.run(function () {
                        _this.autoScroll = atBottom;
                        _this.autoScrollChange.emit(_this.autoScroll);
                    });
                }
            };
            this.scrollToBottom = function (event) {
                if (!_this.autoScroll) {
                    return;
                }
                /** @type {?} */
                var el = _this.element.nativeElement;
                setTimeout(function () {
                    el.scrollTop = el.scrollHeight - el.clientHeight;
                });
                _this.scrolling = true;
                _this.zone.runOutsideAngular(function () { return setTimeout(function () { return _this.scrolling = false; }, 1000); });
            };
            this.scrollToBottomPreset = this.scrollToBottom;
        }
        /**
         * @return {?}
         */
        AutoScrollToBottomDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.zone.runOutsideAngular(function () {
                    _this.renderer.listen(_this.element.nativeElement, 'scroll', function () { return _this.onScroll(); });
                });
            };
        /**
         * @return {?}
         */
        AutoScrollToBottomDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(function () {
                    // scroll to bottom at the beginning
                    // scroll to bottom at the beginning
                    _this.scrollToBottom(null);
                    /** @type {?} */
                    var el = _this.element.nativeElement;
                    /** @type {?} */
                    var wrapper = document.createElement('div');
                    wrapper.setAttribute('style', 'position: relative;');
                    /** @type {?} */
                    var childNodes = el.childNodes;
                    /** @type {?} */
                    var length = childNodes.length;
                    for (var i = 0; i < length; i++) {
                        /** @type {?} */
                        var node = childNodes.item(0);
                        wrapper.appendChild(node);
                    }
                    el.appendChild(wrapper);
                    _this.resized.subscribe(function (event) {
                        _this.scrollToBottomPreset(event);
                    });
                    _this.onResizeFn(wrapper, function (oldVal, newVal) {
                        _this.resized.emit(new ResizedEvent(newVal.width, newVal.height, oldVal.width, oldVal.height));
                    });
                });
            };
        /**
         * @param {?} el
         * @param {?} callback
         * @return {?}
         */
        AutoScrollToBottomDirective.prototype.onResizeFn = /**
         * @param {?} el
         * @param {?} callback
         * @return {?}
         */
            function (el, callback) {
                /** @type {?} */
                var iframe = document.createElement('iframe');
                iframe.setAttribute('style', "\n      width: 100%;\n      height: 100%;\n      position: absolute;\n      visibility:hidden;\n      margin: 0;\n      padding: 0;\n      border: 0;\n      left: 0;\n      top: 0;\n      ");
                el.appendChild(iframe);
                /** @type {?} */
                var oldWidth = el.offsetWidth;
                /** @type {?} */
                var oldHeight = el.offsetHeight;
                /** @type {?} */
                var sizeChange = function () {
                    /** @type {?} */
                    var width = el.offsetWidth;
                    /** @type {?} */
                    var height = el.offsetHeight;
                    // 不一致时触发回调函数 callback，并更新元素当前宽高
                    if (width !== oldWidth || height !== oldHeight) {
                        callback({ width: width, height: height }, { width: oldWidth, height: oldHeight });
                        oldWidth = width;
                        oldHeight = height;
                    }
                };
                /** @type {?} */
                var timer = null;
                // 将 sizeChange 函数挂载到 iframe 的resize回调中
                iframe.contentWindow.onresize = function () {
                    clearTimeout(timer);
                    timer = setTimeout(sizeChange, 33);
                };
            };
        AutoScrollToBottomDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[appAutoScrollToBottom]',
                        exportAs: 'autoScrollDirective'
                    },] }
        ];
        /** @nocollapse */
        AutoScrollToBottomDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.NgZone },
                { type: core.Renderer2 }
            ];
        };
        AutoScrollToBottomDirective.propDecorators = {
            autoScroll: [{ type: core.Input }],
            scrollToBottomPreset: [{ type: core.Input }],
            autoScrollChange: [{ type: core.Output }],
            resized: [{ type: core.Output }],
            overflowAnchor: [{ type: core.HostBinding, args: ['style.overflow-anchor',] }],
            overflowY: [{ type: core.HostBinding, args: ['style.overflow-y',] }]
        };
        return AutoScrollToBottomDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var AngularAutoScrollToBottomModule = /** @class */ (function () {
        function AngularAutoScrollToBottomModule() {
        }
        AngularAutoScrollToBottomModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [],
                        declarations: [AutoScrollToBottomDirective],
                        exports: [AutoScrollToBottomDirective]
                    },] }
        ];
        return AngularAutoScrollToBottomModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    exports.AngularAutoScrollToBottomModule = AngularAutoScrollToBottomModule;
    exports.ResizedEvent = ResizedEvent;
    exports.ɵa = AutoScrollToBottomDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-auto-scroll-to-bottom.umd.js.map